import java.awt.*;
import java.applet.Applet;

public class ShapesApplet extends Applet
{  
   private ActingShape[] shapes;
   private Button b;
   private boolean up = false; // person starts with hand down
   
   
   public void init()
   {  
      shapes = new ActingShape[5];
      
      // note: we can do this in a loop, but we're
      // being explicit for now because we'll change
      // this example later ...
      
      shapes[0] = new Person( 50, 10 );
      shapes[1] = new GirlPerson( 100, 10 );
      shapes[2] = new DancingCircle( 150, 50, 20 );
      shapes[3] = new DancingSquare( 300, 60, 10 );
      shapes[4] = new DancingSquare2( 350, 10, 10 );
      
      
      b = new Button( "Move" );
      this.add( b );
   }

   public boolean action( Event e, Object o )
   {  
      if ( e.target == b )
      {  
         allAct();
         return true;
      }
      else
      {  
         return false;
      }
   }

   public void paint( Graphics g ) 
   {  
      // Note: use persons.length here instead of 3
      // because if we change init() in the future, 
      // then persons might have a different length.
      
      for ( int i = 0; i < shapes.length; i++ )
      {
         shapes[i].draw( g );
      }
   }
   
   /**
    * This method tells all elements of the persons array
    * to act().
    */
   public void allAct()
   {
      for ( int i = 0; i < shapes.length; i++ )
      {
         shapes[i].act();
      }
      repaint();
   }
}
