import java.awt.*;

public class DancingSquare implements ActingShape
{
	protected int x, y;
	protected int side;
	
	protected int state = 0;
	
	public DancingSquare( int x, int y, int side )
	{
		this.x = x;
		this.y = y;
		this.side = side;
	}
	
	public void setXY( int x, int y )
	{
		this.x = x;
		this.y = y;
	}
	
	public int getX()
	{
		return x;
	}
	
	public int getY()
	{
		return y;
	}
	
	public void draw( Graphics g )
	{
		g.drawRect( x, y, side, side );
	}
	
	public void act()
	{
		state = ( state + 1 ) % 2;
		
		switch ( state )
		{
			case 0:
				y = y + 10;
				break;
				
			case 1:
				y = y - 10;
				break;
		}
	}
}