import java.awt.*;
import java.applet.Applet;

/**
 */
public class GirlPerson extends Person
{
   
   public GirlPerson()
   {
      // super() (i.e., Person() constructor)
      // is automatically called
   }
   
   public GirlPerson( int x, int y )
   {
      super( x, y ); // call Person( int x, int y ) constructor
   }
   
   public GirlPerson( int x, int y,
                      int headRadius, int bodyLength,
                      int armWidth, int armLength,
                      int legWidth, int legLength )
   {
      super( x, y, headRadius, bodyLength,
             armWidth, armLength,
             legWidth, legLength );
   }
   
   // convenience method
   
   protected Point getMidPoint( Point p1, Point p2 )
   {
      return new Point( (p1.x + p2.x) / 2,
                        (p1.y + p2.y) / 2 );
   }
   
   public void draw( Graphics g ) 
   {  
      // call Person's draw
      super.draw( g );
      
      // draw skirt as line between midpoints of legs
      drawLine( g, 
                getMidPoint( pelvis, leftFoot ),
                getMidPoint( pelvis, rightFoot ) );
      
   }
   
   
   
}
